
#declare SmokeColor1 = color srgb 0.5;
#declare SmokeColor2 = color srgb 0.6;
#declare SmokeColor3 = color srgb 0.7;

#declare Brown = color srgb < 87 / 255, 43 / 255, 7 / 255 >;
#declare RedFire = color srgb < 251 / 255, 103 / 255, 0 >;
#declare YellowFire = color srgb < 1, 243 / 255, 0 >;

#declare SmokeDensity = density{ bozo density_map{ [0 SmokeColor1 ][0.3 SmokeColor2][0.6 color srgb 0][1 SmokeColor1] } scale 0.1 }
#declare SmokeBorderDensity = density{ bozo density_map{ [ 0.2 color srgb 0 ][ 0.3 SmokeColor1 ][0.6 SmokeColor2 ][ 0.7 color srgb 0 ] } scale 0.25 }
#declare SmokeNullDensity = density{ bozo density_map{ [ 0.33 color srgb 0 ][ 0.66 color srgb 0.1 ] } }

#macro MakeScatteredDirtMedia(RotateVector, Scale, TurbulenceValue, SmokeIntensity)
	media{ absorption 5 * SmokeIntensity scattering{ 1, SmokeColor1 } method 3 samples 30, 30 intervals 1
		density{ spherical density_map{
			[ 0.1 SmokeNullDensity ]
			[ 0.2 SmokeBorderDensity ]
			[ 0.8 SmokeDensity ]
			[ 1 SmokeColor1 ]
							}
			warp{ turbulence TurbulenceValue lambda 2.75 }
		}
		scale Scale
		rotate RotateVector
	}
#end

#declare FirePattern = 
density{ bozo color_map{
	[0 RedFire ]
	[0.6 RedFire ]
	[0.65 YellowFire ]
	[0.95 YellowFire ]
	[1.0 RedFire ]
	}
	scale 0.25
}

#macro MakeFireBallMedia(RotateVector, Scale, TranslateVector, TurbulenceValue, FireIntensity)
	media{ emission 4 * FireIntensity intervals 10
		density{ spherical density_map{
			[ 0.3 color srgb 0 ]
			[ 0.35 FirePattern ]
			[ 1 FirePattern ]
							}
			warp{ turbulence TurbulenceValue lambda 2.25 }
		}
		scale Scale
		rotate RotateVector
		translate TranslateVector
	}
#end
